<?php

/**
 *  2Moons 
 *   by Jan-Otto KrÃ¶pke 2009-2016
 *
 * For the full copyright and license information, please view the LICENSE
 *
 * @package 2Moons
 * @author Jan-Otto KrÃ¶pke <slaver7@gmail.com>
 * @copyright 2009 Lucky
 * @copyright 2016 Jan-Otto KrÃ¶pke <slaver7@gmail.com>
 * @licence MIT
 * @version 1.8.0
 * @link https://github.com/jkroepke/2Moons
 */

abstract class AbstractGamePage
{
	/**
	 * reference of the template object
	 * @var template
	 */
	protected $tplObj;

	/**
	 * reference of the template object
	 * @var ResourceUpdate
	 */
	protected $ecoObj;
	protected $window;
	protected $disableEcoSystem = false;

	protected function __construct() {

		if(!AJAX_REQUEST)
		{
			$this->setWindow('full');
			if(!$this->disableEcoSystem)
			{
				$this->ecoObj	= new ResourceUpdate();
				$this->ecoObj->CalcResource();
			}
			$this->initTemplate();
		} else {
			$this->setWindow('ajax');
		}
	}

	protected function initTemplate() {
		if(isset($this->tplObj))
			return true;

		$this->tplObj	= new template;
		list($tplDir)	= $this->tplObj->getTemplateDir();
		$this->tplObj->setTemplateDir($tplDir.'game/');
		return true;
	}

	protected function setWindow($window) {
		$this->window	= $window;
	}

	protected function getWindow() {
		return $this->window;
	}

	protected function getQueryString() {
		$queryString	= array();
		$page			= HTTP::_GP('page', '');

		if(!empty($page)) {
			$queryString['page']	= $page;
		}

		$mode			= HTTP::_GP('mode', '');
		if(!empty($mode)) {
			$queryString['mode']	= $mode;
		}

		return http_build_query($queryString);
	}

	protected function getCronjobsTodo()
	{
		require_once 'includes/classes/Cronjob.class.php';

		$this->assign(array(
			'cronjobs'		=> Cronjob::getNeedTodoExecutedJobs()
		));
	}
	
	protected function Achievements()
	{
		global $USER, $THEME, $LNG;
		
		//ACHIEVEMENT COMMON PEACE
		if ($USER['peacefull_exp_level'] >= (5 * $USER['achievement_common_1']) + 5){
			$peace_reward_am = 200;
			$peace_reward_points = 100;
			$next_am_peace = min(20000,round($peace_reward_am * pow(1.08, $USER['achievement_common_1'])));
			$next_points_peace = min(20000,round($peace_reward_points * pow(1.08, $USER['achievement_common_1'])));
			$next_level = $USER['achievement_common_1'] + 1;
			$sql	= "UPDATE %%USERS%% SET achievement_common_1 = achievement_common_1 + :achievement_common_1, achievement_common_1_points = achievement_common_1_points + :achievement_common_1_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_common_1'	=> 1,
				':achievement_common_1_points'	=> $next_points_peace,
				':achievement_point'	=> $next_points_peace,
				':antimatter'	=> $next_am_peace,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=general#ach_level"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_level.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_18'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($next_am_peace).' '.$LNG['tech'][922].' <br> '.pretty_number($next_points_peace).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT COMMON COMBAT
		if ($USER['combat_exp_level'] >= (5 * $USER['achievement_common_2']) + 5){
			$combat_reward_am = 400;
			$combat_reward_points = 200;
			$next_am_combat = min(20000,round($combat_reward_am * pow(1.09, $USER['achievement_common_2'])));
			$next_points_combat = min(20000,round($combat_reward_points * pow(1.09, $USER['achievement_common_2'])));
			$next_level = $USER['achievement_common_2'] + 1;
			$sql	= "UPDATE %%USERS%% SET achievement_common_2 = achievement_common_2 + :achievement_common_2, achievement_common_2_points = achievement_common_2_points + :achievement_common_2_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_common_2'	=> 1,
				':achievement_common_2_points'	=> $next_points_combat,
				':achievement_point'	=> $next_points_combat,
				':antimatter'	=> $next_am_combat,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=general#ach_batle_level"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_batle_level.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_20'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($next_am_combat).' '.$LNG['tech'][922].' <br> '.pretty_number($next_points_combat).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD METAL
		$sql	= 'SELECT metal_mine FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY metal_mine DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['metal_mine'] >= (3 * $USER['achievement_build_1']) + 3){
			$metal_reward_am = 7;
			$metal_reward_points = 1;
			$next_level = $USER['achievement_build_1'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.35, $USER['achievement_build_1'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.35, $USER['achievement_build_1'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_1 = achievement_build_1 + :achievement_build_1, achievement_build_1_points = achievement_build_1_points + :achievement_build_1_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_1'	=> 1,
				':achievement_build_1_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_mine_metal"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_mine_metal.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_75'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD CRYSTAL
		$sql	= 'SELECT crystal_mine FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY crystal_mine DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['crystal_mine'] >= (3 * $USER['achievement_build_2']) + 3){
			$metal_reward_am = 7;
			$metal_reward_points = 1;
			$next_level = $USER['achievement_build_2'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.36, $USER['achievement_build_2'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.385, $USER['achievement_build_2'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_2 = achievement_build_2 + :achievement_build_2, achievement_build_2_points = achievement_build_2_points + :achievement_build_2_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_2'	=> 1,
				':achievement_build_2_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_crystal_mine"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_crystal_mine.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_76'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD DEUTERIUM
		$sql	= 'SELECT deuterium_sintetizer FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY deuterium_sintetizer DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['deuterium_sintetizer'] >= (3 * $USER['achievement_build_3']) + 3){
			$metal_reward_am = 7;
			$metal_reward_points = 2;
			$next_level = $USER['achievement_build_3'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.40, $USER['achievement_build_3'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.3834, $USER['achievement_build_3'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_3 = achievement_build_3 + :achievement_build_3, achievement_build_3_points = achievement_build_3_points + :achievement_build_3_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_3'	=> 1,
				':achievement_build_3_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_deuterium_sintetizer"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_deuterium_sintetizer.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_77'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD LIGHT CONV
		$sql	= 'SELECT light_conveyor FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY light_conveyor DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['light_conveyor'] >= (1 * $USER['achievement_build_4']) + 1){
			$metal_reward_am = 28;
			$metal_reward_points = 3;
			$next_level = $USER['achievement_build_4'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.15, $USER['achievement_build_4'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.342, $USER['achievement_build_4'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_4 = achievement_build_4 + :achievement_build_4, achievement_build_4_points = achievement_build_4_points + :achievement_build_4_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_4'	=> 1,
				':achievement_build_4_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_conveyor1"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_conveyor1.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_78'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD MEDIUM CONV
		$sql	= 'SELECT medium_conveyor FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY medium_conveyor DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['medium_conveyor'] >= (1 * $USER['achievement_build_5']) + 1){
			$metal_reward_am = 31;
			$metal_reward_points = 3;
			$next_level = $USER['achievement_build_5'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.16, $USER['achievement_build_5'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.371, $USER['achievement_build_5'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_5 = achievement_build_5 + :achievement_build_5, achievement_build_5_points = achievement_build_5_points + :achievement_build_5_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_5'	=> 1,
				':achievement_build_5_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_conveyor2"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_conveyor2.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_79'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD HEAVY CONV
		$sql	= 'SELECT heavy_conveyor FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY heavy_conveyor DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['heavy_conveyor'] >= (1 * $USER['achievement_build_6']) + 1){
			$metal_reward_am = 33;
			$metal_reward_points = 3;
			$next_level = $USER['achievement_build_6'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.17, $USER['achievement_build_6'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.41, $USER['achievement_build_6'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_6 = achievement_build_6 + :achievement_build_6, achievement_build_6_points = achievement_build_6_points + :achievement_build_6_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_6'	=> 1,
				':achievement_build_6_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_conveyor3"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_conveyor3.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_80'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD UNIVERSITY
		$sql	= 'SELECT university FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY university DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['university'] >= (2 * $USER['achievement_build_7']) + 2){
			$metal_reward_am = 80;
			$metal_reward_points = 30;
			$next_level = $USER['achievement_build_7'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.55, $USER['achievement_build_7'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.55, $USER['achievement_build_7'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_7 = achievement_build_7 + :achievement_build_7, achievement_build_7_points = achievement_build_7_points + :achievement_build_7_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_7'	=> 1,
				':achievement_build_7_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_university"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_university.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_81'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD LUNAR
		$sql	= 'SELECT mondbasis FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY mondbasis DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['mondbasis'] >= (2 * $USER['achievement_build_8']) + 2){
			$metal_reward_am = 35;
			$metal_reward_points = 6;
			$next_level = $USER['achievement_build_8'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.30, $USER['achievement_build_8'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.315, $USER['achievement_build_8'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_8 = achievement_build_8 + :achievement_build_8, achievement_build_8_points = achievement_build_8_points + :achievement_build_8_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_8'	=> 1,
				':achievement_build_8_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_mondbasis"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_mondbasis.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_82'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD PHAKANX
		$sql	= 'SELECT phalanx FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY phalanx DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['phalanx'] >= (2 * $USER['achievement_build_9']) + 2){
			$metal_reward_am = 80;
			$metal_reward_points = 8;
			$next_level = $USER['achievement_build_9'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.40, $USER['achievement_build_9'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.40, $USER['achievement_build_9'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_9 = achievement_build_9 + :achievement_build_9, achievement_build_9_points = achievement_build_9_points + :achievement_build_9_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_9'	=> 1,
				':achievement_build_9_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_phalanx"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_phalanx.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_83'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT BUILD TERRAFORMER
		$sql	= 'SELECT terraformer FROM %%PLANETS%% WHERE id_owner = :id_owner ORDER BY terraformer DESC LIMIT :limit';
		$onlineDatas	= Database::get()->selectSingle($sql, array(
			':id_owner'	=> $USER['id'],
			':limit'	=> 1
		));
		if ($onlineDatas['terraformer'] >= (2 * $USER['achievement_build_10']) + 2){
			$metal_reward_am = 40;
			$metal_reward_points = 7;
			$next_level = $USER['achievement_build_10'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.30, $USER['achievement_build_10'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.315, $USER['achievement_build_10'])));
			$sql	= "UPDATE %%USERS%% SET achievement_build_10 = achievement_build_10 + :achievement_build_10, achievement_build_10_points = achievement_build_10_points + :achievement_build_10_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_build_10'	=> 1,
				':achievement_build_10_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=build#ach_terraformer"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_terraformer.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_84'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		
		//ACHIEVEMENT TECH SPY
		if ($USER['spy_tech'] >= (3 * $USER['achievement_tech_1']) + 3){
			$metal_reward_am = 70;
			$metal_reward_points = 55;
			$next_level = $USER['achievement_tech_1'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.30, $USER['achievement_tech_1'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.30, $USER['achievement_tech_1'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_1 = achievement_tech_1 + :achievement_tech_1, achievement_tech_1_points = achievement_tech_1_points + :achievement_tech_1_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_1'	=> 1,
				':achievement_tech_1_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_spy_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_spy_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_105'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH COMPUTER
		if ($USER['computer_tech'] >= (3 * $USER['achievement_tech_2']) + 3){
			$metal_reward_am = 70;
			$metal_reward_points = 55;
			$next_level = $USER['achievement_tech_2'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.30, $USER['achievement_tech_2'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.30, $USER['achievement_tech_2'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_2 = achievement_tech_2 + :achievement_tech_2, achievement_tech_2_points = achievement_tech_2_points + :achievement_tech_2_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_2'	=> 1,
				':achievement_tech_2_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_computer_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_computer_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_106'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH COMBAT TECH
		if ($USER['military_tech'] >= (2 * $USER['achievement_tech_3']) + 2 && $USER['defence_tech'] >= (2 * $USER['achievement_tech_3']) + 2 && $USER['shield_tech'] >= (2 * $USER['achievement_tech_3']) + 2){
			$metal_reward_am = 20;
			$metal_reward_points = 15;
			$next_level = $USER['achievement_tech_3'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.30, $USER['achievement_tech_3'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.30, $USER['achievement_tech_3'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_3 = achievement_tech_3 + :achievement_tech_3, achievement_tech_3_points = achievement_tech_3_points + :achievement_tech_3_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_3'	=> 1,
				':achievement_tech_3_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_war_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_war_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_107'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH EXPEDITION
		if ($USER['expedition_tech'] >= (4 * $USER['achievement_tech_4']) + 4){
			$metal_reward_am = 65;
			$metal_reward_points = 45;
			$next_level = $USER['achievement_tech_4'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.55, $USER['achievement_tech_4'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.55, $USER['achievement_tech_4'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_4 = achievement_tech_4 + :achievement_tech_4, achievement_tech_4_points = achievement_tech_4_points + :achievement_tech_4_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_4'	=> 1,
				':achievement_tech_4_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']

			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_expedition_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_expedition_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_108'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH GRAVITON
		if ($USER['graviton_tech'] >= (4 * $USER['achievement_tech_5']) + 4 && $USER['achievement_tech_5'] < 20){
			$metal_reward_am = 35;
			$metal_reward_points = 25;
			$next_level = $USER['achievement_tech_5'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.40, $USER['achievement_tech_5'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.40, $USER['achievement_tech_5'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_5 = achievement_tech_5 + :achievement_tech_5, achievement_tech_5_points = achievement_tech_5_points + :achievement_tech_5_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_5'	=> 1,
				':achievement_tech_5_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']
			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_gravity_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_gravity_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_109'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH GUNS
		if ($USER['laser_tech'] >= (2 * $USER['achievement_tech_6']) + 2 && $USER['ionic_tech'] >= (2 * $USER['achievement_tech_6']) + 2 && $USER['buster_tech'] >= (2 * $USER['achievement_tech_6']) + 2){
			$metal_reward_am = 45;
			$metal_reward_points = 30;
			$next_level = $USER['achievement_tech_6'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.40, $USER['achievement_tech_6'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.40, $USER['achievement_tech_6'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_6 = achievement_tech_6 + :achievement_tech_6, achievement_tech_6_points = achievement_tech_6_points + :achievement_tech_6_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_6'	=> 1,
				':achievement_tech_6_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']
			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_gun_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_gun_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_110'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH ENERGY
		if ($USER['energy_tech'] >= (3 * $USER['achievement_tech_7']) + 3){
			$metal_reward_am = 30;
			$metal_reward_points = 20;
			$next_level = $USER['achievement_tech_7'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.45, $USER['achievement_tech_7'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.45, $USER['achievement_tech_7'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_7 = achievement_tech_7 + :achievement_tech_7, achievement_tech_7_points = achievement_tech_7_points + :achievement_tech_7_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_7'	=> 1,
				':achievement_tech_7_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']
			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_energy_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_energy_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_111'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH BROTHERHOOD
		if ($USER['brotherhood'] >= (2 * $USER['achievement_tech_8']) + 2){
			$metal_reward_am = 15;
			$metal_reward_points = 10;
			$next_level = $USER['achievement_tech_8'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.30, $USER['achievement_tech_8'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.30, $USER['achievement_tech_8'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_8 = achievement_tech_8 + :achievement_tech_8, achievement_tech_8_points = achievement_tech_8_points + :achievement_tech_8_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_8'	=> 1,
				':achievement_tech_8_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']
			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_bank_ally_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_bank_ally_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_112'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH SPEED
		if ($USER['combustion_tech'] >= (2 * $USER['achievement_tech_9']) + 2 && $USER['impulse_motor_tech'] >= (2 * $USER['achievement_tech_9']) + 2 && $USER['hyperspace_motor_tech'] >= (2 * $USER['achievement_tech_9']) + 2){
			$metal_reward_am = 25;
			$metal_reward_points = 20;
			$next_level = $USER['achievement_tech_9'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.40, $USER['achievement_tech_9'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.40, $USER['achievement_tech_9'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_9 = achievement_tech_9 + :achievement_tech_9, achievement_tech_9_points = achievement_tech_9_points + :achievement_tech_9_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_9'	=> 1,
				':achievement_tech_9_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']
			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_motor_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_motor_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_113'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		//ACHIEVEMENT TECH PROD
		if ($USER['metal_proc_tech'] >= (2 * $USER['achievement_tech_10']) + 2 && $USER['crystal_proc_tech'] >= (2 * $USER['achievement_tech_10']) + 2 && $USER['deuterium_proc_tech'] >= (2 * $USER['achievement_tech_10']) + 2){
			$metal_reward_am = 20;
			$metal_reward_points = 13;
			$next_level = $USER['achievement_tech_10'] + 1;
			$metal_reward_am = min(20000,round($metal_reward_am * pow(1.30, $USER['achievement_tech_10'])));
			$metal_reward_points = min(20000,round($metal_reward_points * pow(1.30, $USER['achievement_tech_10'])));
			$sql	= "UPDATE %%USERS%% SET achievement_tech_10 = achievement_tech_10 + :achievement_tech_10, achievement_tech_10_points = achievement_tech_10_points + :achievement_tech_10_points, achievement_point = achievement_point + :achievement_point, antimatter = antimatter + :antimatter WHERE id = :userId;";
			database::get()->update($sql, array(
				':achievement_tech_10'	=> 1,
				':achievement_tech_10_points'	=> $metal_reward_points,
				':achievement_point'	=> $metal_reward_points,
				':antimatter'	=> $metal_reward_am,
				':userId'				=> $USER['id']
			));
			$msg = '<a href="game.php?page=achievement&amp;group=tech#ach_mining_tech"><img alt="" style="float:left; width:60px; margin-right:6px;" src="styles/images/achiev/ach_mining_tech.png">'.$LNG['achiev_25'].': <span class="achiev_mes_head">'.sprintf($LNG['achiev_114'], pretty_number($next_level)).'</span><br> '.$LNG['achiev_26'].':<br> '.pretty_number($metal_reward_am).' '.$LNG['tech'][922].' <br> '.pretty_number($metal_reward_points).' '.$LNG['achiev_13'].'</a>';
			PlayerUtil::sendMessage($USER['id'], '', 'System', 4, 'Achievements', $msg, TIMESTAMP);
		}
		//END
		
	}
	protected function Experience()
	{
		global $USER, $THEME;
		
		$config			= Config::get();
		$db = Database::get();
		//PEACEFULL EXPERIECE AND BONUS
		if ($USER['peacefull_exp_current'] >= $USER['peacefull_exp_max']){
			$new_peace_experience =  $USER['peacefull_exp_current'] - $USER['peacefull_exp_max'];
			$new_peace_experience_max =  $USER['peacefull_exp_max'] + 1450/2 ;
			$sql	= "UPDATE %%USERS%% SET peacefull_exp_current = :new_peace_experience, peacefull_exp_max = :new_peace_experience_max, peacefull_exp_level = peacefull_exp_level + 1, academy_p = academy_p + :academy_p WHERE id = :userId;";
			$db->update($sql, array(
				':new_peace_experience'			=> $new_peace_experience,
				':new_peace_experience_max'	=> $new_peace_experience_max,
				':academy_p'					=> $USER['peacefull_exp_level'],
				':userId'						=> $USER['id']
			));
			if (($USER['peacefull_exp_level'] + 1) == ($USER['peacefull_exp_slots'] * 10) + 10  ){
				$sql	= "UPDATE %%USERS%% SET peacefull_exp_slots = peacefull_exp_slots + :peacefull_exp_slots WHERE id = :userId;";
				$db->update($sql, array(
					':peacefull_exp_slots'				=> 1,
					':userId'						=> $USER['id']
				));
			}
			if (($USER['peacefull_exp_level'] + 1) == ($USER['peacefull_exp_mission'] * 20) + 20  ){
				$sql	= "UPDATE %%USERS%% SET peacefull_exp_mission = peacefull_exp_mission + :peacefull_exp_mission WHERE id = :userId;";
				$db->update($sql, array(
					':peacefull_exp_mission'				=> 5,
					':userId'						=> $USER['id']
				));
			}
			if (($USER['peacefull_exp_level'] + 1) == ($USER['peacefull_exp_moonshot'] * 15) + 20  ){
				$sql	= "UPDATE %%USERS%% SET peacefull_exp_moonshot = peacefull_exp_moonshot + :peacefull_exp_moonshot WHERE id = :userId;";
				$db->update($sql, array(
					':peacefull_exp_moonshot'				=> 2,
					':userId'						=> $USER['id']
				));
			}
			if (($USER['peacefull_exp_level'] + 1) == ($USER['peacefull_exp_light'] * 10) + 20  ){
				$sql	= "UPDATE %%USERS%% SET peacefull_exp_light = peacefull_exp_light + :peacefull_exp_light WHERE id = :userId;";
				$db->update($sql, array(
					':peacefull_exp_light'				=> 1,
					':userId'						=> $USER['id']
				));
			}
			if (($USER['peacefull_exp_level'] + 1) == ($USER['peacefull_exp_medium'] * 10) + 30  ){
				$sql	= "UPDATE %%USERS%% SET peacefull_exp_medium = peacefull_exp_medium + :peacefull_exp_medium WHERE id = :userId;";
				$db->update($sql, array(
					':peacefull_exp_medium'				=> 1,
					':userId'						=> $USER['id']
				));
			}
			if (($USER['peacefull_exp_level'] + 1) == ($USER['peacefull_exp_heavy'] * 10) + 40  ){
				$sql	= "UPDATE %%USERS%% SET peacefull_exp_heavy = peacefull_exp_heavy + :peacefull_exp_heavy WHERE id = :userId;";
				$db->update($sql, array(
					':peacefull_exp_heavy'				=> 1,
					':userId'						=> $USER['id']
				));
			}
		}
		if($USER['urlaubs_modus'] == 0 && $USER['onlinetime'] > TIMESTAMP - 3 * 60 || $USER['peacefull_last_update'] == 0){
			$premium_leveling = 0;
			if($USER['prem_leveling'] > 0 && $USER['prem_leveling_days'] > TIMESTAMP){
				$premium_leveling = $USER['prem_leveling'];
			}
			
			$premium_admin = 1;
			if($config->peacefullExp > 0){
				$premium_admin = $config->peacefullExp;
			}
			
			$ally_fraction_peace_exp = 0;
			if($USER['ally_id'] != 0){
				$sql	= 'SELECT * FROM %%ALLIANCE%% WHERE id = :allyID;';
				$ALLIANCE = Database::get()->selectSingle($sql, array(
					':allyID'	=> $USER['ally_id']
				));
				if($ALLIANCE['ally_fraction_id'] != 0 && $ALLIANCE['ally_fraction_level'] != 0){
					$sql	= 'SELECT * FROM %%ALLIANCEFRACTIONS%% WHERE ally_fraction_id = :ally_fraction_id;';
					$FRACTIONS = Database::get()->selectSingle($sql, array(
						':ally_fraction_id'	=> $ALLIANCE['ally_fraction_id']
					));
					$ally_fraction_peace_exp = $FRACTIONS['ally_fraction_peace_exp'] * $ALLIANCE['ally_fraction_level'];
				}
			}
			
			$ProductionTime  			= (TIMESTAMP - $USER['peacefull_last_update']);
			$expProd = $ProductionTime * 3600 / (3600 + 210 * $USER['peacefull_exp_level']);	
			//$expProd += ($expProd / 100 * $premium_leveling) + ($expProd * $premium_admin);		
			$expProd += ($expProd / 100 * $premium_leveling) + ($expProd * $premium_admin) + ($expProd / 100 * $ally_fraction_peace_exp);	

			if(config::get(ROOT_UNI)->happyHourEvent == 1 && config::get(ROOT_UNI)->happyHourTime < TIMESTAMP && (config::get(ROOT_UNI)->happyHourTime + 3600) > TIMESTAMP)
				$expProd = $expProd * config::get()->happyHourBonus;
			
			if($expProd > 0 && $USER['onlinetime'] > TIMESTAMP - 3 * 60){
				$sql	= "UPDATE %%USERS%% SET peacefull_exp_current = peacefull_exp_current + :peacefull_exp_current, peacefull_last_update = :peacefull_last_update WHERE id = :userId;";
				$db->update($sql, array(
					':peacefull_exp_current'				=> $expProd,
					':peacefull_last_update'				=> TIMESTAMP,
					':userId'						=> $USER['id']
				));
			}
		}else{
			$sql	= "UPDATE %%USERS%% SET peacefull_last_update = :peacefull_last_update WHERE id = :userId;";
			$db->update($sql, array(
				':peacefull_last_update'				=> TIMESTAMP,
				':userId'						=> $USER['id']
			));	
		}
		//END PEACEFULL EXPERIENCE AND BONUS
		
		//COMBAT EXPERIENCE AND BONUS
		if ($USER['combat_exp_current'] >= $USER['combat_exp_max']){
			$new_combat_experience =  $USER['combat_exp_current'] - $USER['combat_exp_max'];
			$new_combat_experience_max =  floor(10700 * pow(1.15,$USER['combat_exp_level']+1)); 
			$sql	= "UPDATE %%USERS%% SET combat_exp_current = :new_combat_experience, combat_exp_max = :new_combat_experience_max, combat_exp_level = combat_exp_level + 1, academy_p = academy_p + :academy_p WHERE id = :userId;"; 
			$db->update($sql, array(
				':new_combat_experience'		=> $new_combat_experience,
				':new_combat_experience_max'	=> $new_combat_experience_max,
				':academy_p'					=> $USER['combat_exp_level'],
				':userId'						=> $USER['id']
			));
			if ($USER['combat_exp_level'] + 1  >= ($USER['combat_exp_deut'] * 3) + 3){
				$sql	= "UPDATE %%USERS%% SET combat_exp_deut = combat_exp_deut + 1 WHERE id = :userId;";
				$db->update($sql, array(
					':userId'						=> $USER['id']
				));
			}
			if ($USER['combat_exp_level'] + 1  >= ($USER['combat_exp_expedition'] * 5) + 5){
				$sql	= "UPDATE %%USERS%% SET combat_exp_expedition = combat_exp_expedition + 1 WHERE id = :userId;";
				$db->update($sql, array(
					':userId'						=> $USER['id']
				));
			}
			if ($USER['combat_exp_level'] + 1  >= ($USER['combat_exp_bonus'] * 8) + 8){
				$sql	= "UPDATE %%USERS%% SET combat_exp_bonus = combat_exp_bonus + 1 WHERE id = :userId;";
				$db->update($sql, array(
					':userId'						=> $USER['id']
				));
			}
			if ($USER['combat_exp_level'] + 1  >= ($USER['combat_exp_collider'] * 15) + 15){
				$sql	= "UPDATE %%USERS%% SET combat_exp_collider = combat_exp_collider + 1 WHERE id = :userId;";
				$db->update($sql, array(
					':userId'						=> $USER['id']
				));
			}
			if ($USER['combat_exp_level'] + 1  >= ($USER['combat_exp_upgrade'] * 25) + 25){
				$sql	= "UPDATE %%USERS%% SET combat_exp_upgrade = combat_exp_upgrade + 1 WHERE id = :userId;";
				$db->update($sql, array(
					':userId'						=> $USER['id']
				));
			}
		}
		//END COMBAT EXPERIENCE AND BONUS
	}
	

	protected function getNavigationData()
	{
		global $PLANET, $LNG, $USER, $THEME, $resource, $reslist, $pricelist;

		$config			= Config::get();
		$db 			= Database::get();

		$PlanetSelect	= array();

		if(isset($USER['PLANETS'])) {
			$USER['PLANETS']	= getPlanets($USER);
		}

		foreach($USER['PLANETS'] as $PlanetQuery)
		{
			$PlanetSelect[$PlanetQuery['id']]	= $PlanetQuery['name'].(($PlanetQuery['planet_type'] == 3) ? " (" . $LNG['fcm_moon'] . ")":"")." [".$PlanetQuery['galaxy'].":".$PlanetQuery['system'].":".$PlanetQuery['planet']."]";
		}

		$resourceTable	= array();
		$resourceSpeed	= $config->resource_multiplier;
		foreach($reslist['resstype'][1] as $resourceID)
		{
			$resourceTable[$resourceID]['name']			= $resource[$resourceID];
			$resourceTable[$resourceID]['current']		= $PLANET[$resource[$resourceID]];
			$resourceTable[$resourceID]['max']			= $PLANET[$resource[$resourceID].'_max'];
			if($USER['urlaubs_modus'] == 1 || $PLANET['planet_type'] != 1)
			{
				$resourceTable[$resourceID]['production']	= $PLANET[$resource[$resourceID].'_perhour'];
			}
			else
			{
				$resourceTable[$resourceID]['production']	= $PLANET[$resource[$resourceID].'_perhour'] + $config->{$resource[$resourceID].'_basic_income'} * $resourceSpeed;
			}
		}

		foreach($reslist['resstype'][2] as $resourceID)
		{
			$resourceTable[$resourceID]['name']			= $resource[$resourceID];
			$resourceTable[$resourceID]['used']			= $PLANET[$resource[$resourceID].'_used'];
			$resourceTable[$resourceID]['max']			= $PLANET[$resource[$resourceID]];
		}

		foreach($reslist['resstype'][3] as $resourceID)
		{
			$resourceTable[$resourceID]['name']			= $resource[$resourceID];
			$resourceTable[$resourceID]['current']		= $USER[$resource[$resourceID]];
		}

				// Mise en place comteur pour le bonus
		if($USER['bonus_attente_time'] == 0){
      
      		$BonusTemps = 0;
		$secsBonus = 0;
    
    }
		if($USER['bonus_attente_time'] < TIMESTAMP && $USER['bonus_attente_time'] != 0){
			$time = 0;
			$db->update("UPDATE %%USERS%% SET `bonus_attente_time` = ". $time .";");
		}
		if ($USER['bonus_attente_time'] > TIMESTAMP){
			$secsBonus = $USER['bonus_attente_time'] - TIMESTAMP;
		}
		// fin de la Mise en place comteur pour le bonus
		
		/**
		 * Addition for moving planet with arrows
		 * Ajout pour le dÃ©placement de planÃ¨te avec les flÃ¨ches
		**/
		$previousPlanet = $db->selectSingle("SELECT id FROM %%PLANETS%% WHERE id < :planetID AND id_owner = :userID AND destruyed = '0' ORDER BY id DESC LIMIT 1 ;", array(':planetID' => $PLANET['id'], ':userID' => $USER['id']));
		$nextPlanet = $db->selectSingle("SELECT id FROM %%PLANETS%% WHERE id > :planetID AND id_owner = :userID AND destruyed = '0' ORDER BY id ASC LIMIT 1 ;", array(':planetID' => $PLANET['id'], ':userID' => $USER['id']));

		$themeSettings	= $THEME->getStyleSettings();
		
			if($USER['tutorial'] != -1){
		$db = Database::get();
		if($USER['tutorial'] == 0){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 1
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 1){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 2
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 2 && $this->getQueryString() == "page=buildings"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 4
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 5){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 6
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 9){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 10
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 11){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 12
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 12){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 13
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
			$rawfleetarray 		= array(210 => 1);
			$fleetStartTime		= 80 + TIMESTAMP;
			$timeDifference		= round(max(0, $fleetStartTime - 0));
			$fleetStayTime		= $fleetStartTime;
			$fleetEndTime		= $fleetStayTime + 80;
			$fleetResource		= array(
				901	=> 0,
				902	=> 0,
				903	=> 0,
			);
			FleetFunctions::sendFleet($rawfleetarray, 6, 0, 0, $PLANET['galaxy'],
				$PLANET['system'], 21, 1, $PLANET['id_owner'],
				$PLANET['id'], $PLANET['galaxy'], $PLANET['system'], $PLANET['planet'], $PLANET['planet_type'], $fleetResource,
				$fleetStartTime, $fleetStayTime, $fleetEndTime, 0);
		}
		if($USER['tutorial'] == 13 && $this->getQueryString() == "page=overview"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 14
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 14 && $this->getQueryString() != "page=nono"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 15
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 14 && $this->getQueryString() == "page=research"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 17
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 15 && $this->getQueryString() != "page=research"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 16
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 16){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 17
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 15 && $this->getQueryString() != "page=research"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 16
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 17){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 18
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		} 
		if($USER['tutorial'] == 20){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 21,
			peacefull_exp_current	= peacefull_exp_current + :peacefull_exp_current
			WHERE id = :userID;";
			$db->update($sql, array(
			':peacefull_exp_current'			=> 650,
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 22){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 23
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 21 && $this->getQueryString() == "page=defense"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 22
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 28 && $this->getQueryString() == "page=overview"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 29
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		
		//ATTACK PART
		$totalAttacks = 0;
		$sql	= 'SELECT COUNT(fleet_id) as fleet_id FROM %%FLEETS%% WHERE fleet_target_owner = :userId AND fleet_mission = :missionID AND fleet_mess = :mesID';
		$totalAttacks	= Database::get()->selectSingle($sql, array(
		':userId'	=> $USER['id'],
		':missionID'	=> 1,
		':mesID'	=> 0
		), 'fleet_id');
		if($totalAttacks != 0){
			$totalAttacks = $totalAttacks;	
		}
		//END ATTACK PART
		
		if($USER['tutorial'] == 29 && $totalAttacks == 0){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 30
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 30 && $this->getQueryString() == "page=messages"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 31
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 32){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 33
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 39 && $this->getQueryString() == "page=galaxy"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 40
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id'] 
			));
		}
		if($USER['tutorial'] == 41){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 42
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 40 && $this->getQueryString() == "page=overview"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 41
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 44){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 45
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 46){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 47
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		
		if($USER['tutorial'] == 49){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= -1
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 48){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 49
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 47 && $this->getQueryString() == "page=achievement"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 48
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 51 && HTTP::_GP('page', '') == "fleetTable"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= -1
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		/*if($USER['tutorial'] > 52){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= -1
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] = 52){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= -1
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 54 && $USER['expedition_tech'] >= 1 && $PLANET['big_ship_cargo'] >= 1000 && $PLANET['light_hunter'] >= 10000 && $PLANET['battle_ship'] >= 1500 && $PLANET['recycler'] >= 10){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 55
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 55 && HTTP::_GP('page', '') == "fleetTable"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 56
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 57){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 58
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
			$sql =  "UPDATE %%PLANETS%% SET
			light_hunter = light_hunter + :light_hunter,
			heavy_hunter = heavy_hunter + :heavy_hunter,
			crusher		 = crusher + :crusher,
			battle_ship	 = battle_ship + :battle_ship,
			battleship	 = battleship + :battleship,
			giga_recykler	 = giga_recykler + :giga_recykler
			WHERE id = :planetId;";
			$db->update($sql, array(
			':light_hunter'			=> 150000,
			':heavy_hunter'			=> 24000,
			':crusher'				=> 49000,
			':battle_ship'			=> 9850,
			':battleship'			=> 3500,
			':giga_recykler'		=> 25,
			':planetId'				=> $PLANET['id']
			));
		}
		if($USER['tutorial'] == 58 && $PLANET['crusher'] >= 1000 && $PLANET['heavy_hunter'] >= 25000){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 59
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 59 && HTTP::_GP('page', '') == "fleetTable"){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 60
			WHERE id = :userID;";
			$db->update($sql, array(
			':userID'			=> $USER['id']
			));
		}
		if($USER['tutorial'] == 61){
			$sql =  "UPDATE %%USERS%% SET
			tutorial				= 62,
			combat_exp_current	= combat_exp_current + :combat_exp_current
			WHERE id = :userID;";
			$db->update($sql, array(
			':combat_exp_current'			=> 1000,
			':userID'			=> $USER['id']
			));
		}*/
	}else{
		//ATTACK PART
		$totalAttacks = 0;
		$sql	= 'SELECT COUNT(fleet_id) as fleet_id FROM %%FLEETS%% WHERE fleet_target_owner = :userId AND fleet_mission = :missionID AND fleet_mess = :mesID';
		$totalAttacks	= Database::get()->selectSingle($sql, array(
		':userId'	=> $USER['id'],
		':missionID'	=> 1,
		':mesID'	=> 0
		), 'fleet_id');
		if($totalAttacks != 0){
		$totalAttacks = $totalAttacks;	
		}
		//END ATTACK PART
	}

		//ROCKET PART
		$totalRockets = 0;
		$sql	= 'SELECT COUNT(fleet_id) as fleet_id FROM %%FLEETS%% WHERE fleet_target_owner = :userId AND fleet_mission = :missionID AND fleet_mess = :mesID';
		$totalRockets	= Database::get()->selectSingle($sql, array(
		':userId'	=> $USER['id'],
		':missionID'	=> 10,
		':mesID'	=> 0
		), 'fleet_id');
		if($totalRockets != 0){
		$totalRockets = $totalRockets;	
		}
		//END ROCKET PART

		//SPIO PART
		$totalSpio = 0;
		$sql	= 'SELECT COUNT(fleet_id) as fleet_id FROM %%FLEETS%% WHERE fleet_target_owner = :userId AND fleet_mission = :missionID AND fleet_mess = :mesID';
		$totalSpio	= Database::get()->selectSingle($sql, array(
		':userId'	=> $USER['id'],
		':missionID'	=> 6,
		':mesID'	=> 0
		), 'fleet_id');
		if($totalSpio != 0){
		$totalSpio = $totalSpio;	
		}
		//END SPIO PART
		
		//CAPTURE PART
		$totalCapture = 0;
		$sql	= 'SELECT COUNT(fleet_id) as fleet_id FROM %%FLEETS%% WHERE fleet_target_owner = :userId AND fleet_mission = :missionID AND fleet_mess != :mesID';
		$totalCapture	= Database::get()->selectSingle($sql, array(
		':userId'	=> $USER['id'],
		':missionID'	=> 25,
		':mesID'	=> 1
		), 'fleet_id');
		if($totalCapture != 0){
		$totalCapture = $totalCapture;	
		}
		//END CAPTURE PART
		

		$this->assign(array(
			'PlanetSelect'		=> $PlanetSelect,
			'new_message' 		=> $USER['messages'],
			'vacation'			=> $USER['urlaubs_modus'] ? _date($LNG['php_tdformat'], $USER['urlaubs_until'], $USER['timezone']) : false,
			'delete'			=> $USER['db_deaktjava'] ? sprintf($LNG['tn_delete_mode'], _date($LNG['php_tdformat'], $USER['db_deaktjava'] + ($config->del_user_manually * 86400)), $USER['timezone']) : false,
			'darkmatter'		=> $USER['darkmatter'],
			'current_pid'		=> $PLANET['id'],
			'image'				=> $PLANET['image'],
			'resourceTable'		=> $resourceTable,
			'shortlyNumber'		=> $themeSettings['TOPNAV_SHORTLY_NUMBER'],
			'closed'			=> !$config->game_disable,
			'hasBoard'			=> filter_var($config->forum_url, FILTER_VALIDATE_URL, FILTER_FLAG_SCHEME_REQUIRED),
			'hasAdminAccess'	=> !empty(Session::load()->adminAccess),
			'hasGate'			=> $PLANET[$resource[43]] > 0,
			'username'			=> $USER['username'],
			'sawfb'				=> $USER['sawfb'],
			'sawminially'		=> $USER['sawminially'],
			'sirena'				=> $USER['sirena'] / 10,
			'bonus'             => $USER['bonus_attente_time'],
			'previousPlanet'	=> $previousPlanet['id'],
			'nextPlanet'		=> $nextPlanet['id'],
			'totalAttacks'			=> $totalAttacks,
				'totalRockets'			=> $totalRockets,
				'totalSpio'				=> $totalSpio,
  
		));
	}
	
		protected function getDbonusData()
	{
		global $CONF, $LNG, $PLANET, $USER, $resource, $UNI;
		
			/* $local_search = $GLOBALS['DATABASE']->query("SELECT * FROM `uni1_timebonus_log` where `userID` = ".$USER['id'].";");
			if($CONF['timeRewardFrom'] < TIMESTAMP && $CONF['timeRewardTo'] > TIMESTAMP && $GLOBALS['DATABASE']->numRows($local_search)==0){
			$GLOBALS['DATABASE']->query("UPDATE ".USERS." SET antimatter = antimatter + '".$CONF['timeReward']."' WHERE id = ".$USER['id'].";");
			$GLOBALS['DATABASE']->query("INSERT INTO uni1_timebonus_log VALUES ('".$GLOBALS['DATABASE']->GetInsertID()."','".$USER['id']."', ".TIMESTAMP.");");
			} */
			
		if($USER['sdays_time'] < TIMESTAMP - 48 * 60 * 60 ){
		$db = Database::get();
		$xxx = 1;
		}
		else{
		$xxx = 1;
		if($USER['sdays_b'] == 1 )
		$xxx = 1;
		if($USER['sdays_b'] == 2 )
		$xxx = 2;
		if($USER['sdays_b'] == 3 )
		$xxx = 3;
		if($USER['sdays_b'] == 4 )
		$xxx = 4;
		if($USER['sdays_b'] == 5 )
		$xxx = 5;
		if($USER['sdays_b'] == 6 )
		$xxx = 6;
		if($USER['sdays_b'] == 7 )
		$xxx = 7;
		}
		$BID = $USER['sdays_b'];
		$randomd = mt_rand(1,6);
			$this->tplObj->assign_vars(array(
			'randomd' => $randomd,
			'mode1' => $BID,
			'xxx' => $xxx,
			'rewardss' => pretty_number($USER['experience_peace_max'] / 100 * 5),
			'show_dbonus' => (($USER['sdays_time']  > TIMESTAMP - 60 * 60 * 24) ?  1 : 2 ),
				));
	}

	protected function getPageData()
	{
		global $USER, $THEME;

		if($this->getWindow() === 'full') {
			$this->getNavigationData();
			$this->getCronjobsTodo();
			$this->getDbonusData();
			
		}

		$dateTimeServer		= new DateTime("now");
		if(isset($USER['timezone'])) {
			try {
				$dateTimeUser	= new DateTime("now", new DateTimeZone($USER['timezone']));
			} catch (Exception $e) {
				$dateTimeUser	= $dateTimeServer;
			}
		} else {
			$dateTimeUser	= $dateTimeServer;
		}

		$config	= Config::get();
		
		        $sql	= "SELECT COUNT(*) as count FROM %%FLEETS%% WHERE fleet_start_time > :time AND fleet_mission = :missionId AND fleet_mess = 0 AND fleet_owner <> :userId AND fleet_target_owner = :userId;";
        $total	= Database::get()->selectSingle($sql, array(
            ':userId'	    => $USER['id'],
            ':time'	        => TIMESTAMP,
            ':missionId'	=> 1
            
        ));
        $AJAX['ataks'] = $total['count'];

        $sql	= "SELECT COUNT(*) as count FROM %%FLEETS%% WHERE fleet_start_time > :time AND fleet_mission = :missionId AND fleet_mess = 0 AND fleet_owner <> :userId AND fleet_target_owner = :userId;";
        $total	= Database::get()->selectSingle($sql, array(
            ':userId'	    => $USER['id'],
            ':time'	        => TIMESTAMP,
            ':missionId'	=> 6
            
        ));
        $AJAX['spio'] = $total['count'];

        $sql	= "SELECT COUNT(*) as count FROM %%FLEETS%% WHERE fleet_start_time > :time AND fleet_mission = :missionId AND fleet_mess = 0 AND fleet_owner <> :userId AND fleet_target_owner = :userId;";
        $total	= Database::get()->selectSingle($sql, array(
            ':userId'	    => $USER['id'],
            ':time'	        => TIMESTAMP,
            ':missionId'	=> 9
            
        ));
        $AJAX['unic'] = $total['count'];

        $sql	= "SELECT COUNT(*) as count FROM %%FLEETS%% WHERE fleet_start_time > :time AND fleet_mission = :missionId AND fleet_mess = 0 AND fleet_owner <> :userId AND fleet_target_owner = :userId;";
        $total	= Database::get()->selectSingle($sql, array(
            ':userId'	    => $USER['id'],
            ':time'	        => TIMESTAMP,
            ':missionId'	=> 10
            
        ));
        $AJAX['rakets'] = $total['count'];

		$this->assign(array(
			'vmode'				=> $USER['urlaubs_modus'],
			'authlevel'			=> $USER['authlevel'],
			'userID'			=> $USER['id'],
			'bodyclass'			=> $this->getWindow(),
			'game_name'			=> $config->game_name,
			'uni_name'			=> $config->uni_name,
			'tutorial'			=> $USER['tutorial'], 
			'ga_active'			=> $config->ga_active,
			'ga_key'			=> $config->ga_key,
			'debug'				=> $config->debug,
			'VERSION'			=> $config->VERSION,
			'date'				=> explode("|", date('Y\|n\|j\|G\|i\|s\|Z', TIMESTAMP)),
			'isPlayerCardActive' => isModuleAvailable(MODULE_PLAYERCARD),
			'REV'				=> substr($config->VERSION, -4),
			'Offset'			=> $dateTimeUser->getOffset() - $dateTimeServer->getOffset(),
			'queryString'		=> $this->getQueryString(),
			'themeSettings'		=> $THEME->getStyleSettings(),
			 //??????????
            'ataks'				=> $AJAX['ataks'],
			'spio'				=> $AJAX['spio'],
			'unic'				=> $AJAX['unic'],
			'rakets'			=> $AJAX['rakets'],

		));
	}
	protected function printMessage($message, $redirectButtons = NULL, $redirect = NULL, $fullSide = true)
	{
		$this->assign(array(
			'message'			=> $message,
			'redirectButtons'	=> $redirectButtons,
		));

		if(isset($redirect)) {
			$this->tplObj->gotoside($redirect[0], $redirect[1]);
		}

		if(!$fullSide) {
			$this->setWindow('popup');
		}

		$this->display('error.default.tpl');
	}

	protected function save() {
		if(isset($this->ecoObj)) {
			$this->ecoObj->SavePlanetToDB();
		}
	}

	protected function assign($array, $nocache = true) {
		$this->tplObj->assign_vars($array, $nocache);
	}

	protected function display($file) {
		global $THEME, $LNG, $USER;

		$this->save();

		if($this->getWindow() !== 'ajax') {
			$this->getPageData();
		}

		$this->assign(array(
			'lang'    		=> $LNG->getLanguage(),
			'dpath'			=> $THEME->getTheme(),
			'scripts'		=> $this->tplObj->jsscript,
			'execscript'	=> implode("\n", $this->tplObj->script),
			'basepath'		=> PROTOCOL.HTTP_HOST.HTTP_BASE,
			'servertime'	=> _date("M D d H:i:s", TIMESTAMP, $USER['timezone']),
		));

		$this->assign(array(
			'LNG'			=> $LNG,
		), false);

		$this->tplObj->display('extends:layout.'.$this->getWindow().'.tpl|'.$file);
		exit;
	}

	protected function sendJSON($data) {
		$this->save();
		echo json_encode($data);
		exit;
	}

	protected function redirectTo($url) {
		$this->save();
		HTTP::redirectTo($url);
		exit;
	}
}